package javademo;

import java.awt.BasicStroke;
import java.awt.Color;
import java.awt.Font;
import java.awt.Graphics2D;
import java.awt.Image;
import java.awt.Point;
import java.awt.Rectangle;
import java.awt.Shape;
import java.awt.geom.Point2D;
import java.awt.geom.Rectangle2D;
import java.util.Random;

public class CustomIcon {
  private transient MainFrame main_frame = null;

  String s1;
  String s2;
  String s3;

  public static final long SELECTED                 = 1 << 0;
  public static final long _LAST_STATE_             = 1 << 1;
  public static final long CLEAR_ALL_BITS   = (_LAST_STATE_ - 1);
  private long   icon_state = 0;

  public Point2D icon_offset   = new Point2D.Double(0.0, 0.0);
  public Point2D icon_node     = new Point2D.Double(0.0, 0.0);
  public Point2D icon_end_node = new Point2D.Double(0.0, 0.0);

  protected int icon_bdr_inner_w  = 2;
  protected int icon_bdr_center_w = 2;
  protected int icon_bdr_outer_w  = 2;
  protected int icon_inset = icon_bdr_inner_w + icon_bdr_center_w + icon_bdr_outer_w; //6

  protected Rectangle icon_bounds = new Rectangle(
    0,
    0,
    (icon_inset * 2) + 78, //12 +  78 =  90
    (icon_inset * 2) + 118 //12 + 118 = 130
  );

  protected Shape icon_bdr_outer  = new Rectangle2D.Double(
    icon_bdr_outer_w / 2, //2 / 2 = 1
    icon_bdr_outer_w / 2, //2 / 2 = 1
    icon_bounds.width  - icon_bdr_outer_w, // 90 - 2 =  88
    icon_bounds.height - icon_bdr_outer_w  //130 - 2 = 128
  );
  protected Shape icon_bdr_center = new Rectangle2D.Double(
    icon_bdr_outer_w   + (icon_bdr_center_w / 2), //2 + 1 = 3
    icon_bdr_outer_w   + (icon_bdr_center_w / 2), //2 + 1 = 3
    icon_bounds.width  - ((icon_bdr_outer_w * 2) + icon_bdr_center_w), // 90 - (4 + 2) =  84
    icon_bounds.height - ((icon_bdr_outer_w * 2) + icon_bdr_center_w)  //130 - (4 + 2) = 124
  );
  protected Shape icon_bdr_inner  = new Rectangle2D.Double(
    icon_bdr_outer_w   + icon_bdr_center_w + (icon_bdr_inner_w / 2), //2 + 2 + 1 = 5
    icon_bdr_outer_w   + icon_bdr_center_w + (icon_bdr_inner_w / 2), //2 + 2 + 1 = 5
    icon_bounds.width  - (((icon_bdr_outer_w + icon_bdr_center_w) * 2) + icon_bdr_inner_w), // 90 - (((2 + 2) * 2) + 2) =  80
    icon_bounds.height - (((icon_bdr_outer_w + icon_bdr_center_w) * 2) + icon_bdr_inner_w)  //130 - (((2 + 2) * 2) + 2) = 120
  );

  protected Shape icon_fill = new Rectangle2D.Double(
    icon_inset, //6
    icon_inset, //6
    icon_bounds.width  - (icon_inset * 2), // 90 - 12 =  78
    icon_bounds.height - (icon_inset * 2)  //130 - 12 = 118
  );

  protected transient Image icon_img_icon;
  //                                                    X,                Y                X,             Y
  protected Point icon_icon   = new Point(icon_inset + 20, icon_inset +  17 + 8); // 6 + 20 = 26, 6 +  17 =  23
  protected Point icon_mac    = new Point(icon_inset + 11, icon_inset +  13); // 6 + 11 = 17, 6 +  13 =  19
  protected Point icon_model  = new Point(0, icon_inset +  93 + 8); //X is calculated on paint  , 6 +  93 =  99
  protected Point icon_serial = new Point(icon_inset + 13, icon_inset + 110 + 4); // 6 + 13 = 19, 6 + 110 = 116
  protected Point icon_root   = new Point(icon_inset + 35, icon_inset +  32); // 6 + 35 = 41, 6 +  32 =  38

  protected int icon_handle_line_w = 1;
  protected int icon_handle_hit_size = 10;

  protected Shape icon_lhandle = new Rectangle2D.Double(
    icon_inset +  5, //6 +  5 = 11
    icon_inset + 52, //6 + 52 = 58
    icon_handle_hit_size, //10
    icon_handle_hit_size  //10
  );
  protected Shape icon_rhandle = new Rectangle2D.Double(
    icon_inset + 62, //6 + 62 = 68
    icon_inset + 52, //6 + 52 = 58
    icon_handle_hit_size, //10
    icon_handle_hit_size  //10
  );

  public CustomIcon(MainFrame main_frame) {
    this.main_frame = main_frame;
    Random r = new Random();

    s1 = "";
    s2 = "";
    s3 = "";

    for(int i = 0; i < 9; i++) {
      s1 += (char)r.ints(0x30, 0x39).findFirst().getAsInt();
    }

    for(int i = 0; i < 9; i++) {
      s2 += (char)r.ints(0x41, 0x5A).findFirst().getAsInt();
    }

    for(int i = 0; i < 9; i++) {
      s3 += (char)r.ints(0x61, 0x7A).findFirst().getAsInt();
    }

  }

  public MainFrame get_network_frame() {
    return main_frame;
  }

  private void _icon_set_icon(String radio_icon) {
    icon_img_icon = new javax.swing.ImageIcon(ClassLoader.getSystemResource(radio_icon)).getImage();
  }

  public void icon_set_icon(String radio_icon) {
    _icon_set_icon(radio_icon);
  }

  public boolean icon_has_icon() {
    return (icon_img_icon != null);
  }

  public void icon_set_bounds(int x, int y, int width, int height) {
    icon_bounds.setLocation(x, y);
    icon_bounds.setSize(width, height);
  }

  public Rectangle icon_get_bounds() {
    return icon_bounds;
  }

	public int icon_get_x() {
		return icon_bounds.x;
	}

	public int icon_get_y() {
		return icon_bounds.y;
	}

	public void icon_set_x(int x) {
		icon_bounds.x = x;
	}

	public void icon_set_y(int y) {
		icon_bounds.y = y;
	}

  public int icon_get_width() {
    return icon_bounds.width;
  }

  public int icon_get_height() {
    return icon_bounds.height;
  }

  public Point icon_get_location() {
    return icon_get_bounds().getLocation();
  }

  public long icon_state_history() {
    //System.out.printf("%s: %s: %s\n", "icon_state_history", detail_get_string(eRadioDetails.DETAIL_SERIAL), get_states(icon_state));
    return icon_state;
  }

  public void icon_state_history(long icon_state) {
    this.icon_state = icon_state;
    //System.out.printf("%s: %s: %s\n", "icon_state_history", detail_get_string(eRadioDetails.DETAIL_SERIAL), get_states(icon_state));
  }

  public void icon_set_location(Point p) {
    icon_get_bounds().setLocation(p);
  }

	public boolean icon_is_handle(double x, double y) {
      Rectangle2D lh = (Rectangle2D)icon_lhandle.getBounds2D();
      Rectangle2D rh = (Rectangle2D)icon_rhandle.getBounds2D();
      Rectangle2D mp = new Rectangle2D.Double(x - (icon_handle_hit_size / 2), y - (icon_handle_hit_size / 2), icon_handle_hit_size, icon_handle_hit_size);
			return lh.intersects(mp) || rh.intersects(mp);
	}

  public Color icon_get_color() {
    return Color.blue;
  }

  public BasicStroke icon_get_stroke() {
    BasicStroke solid = new BasicStroke(icon_bdr_inner_w);
    BasicStroke dashed = new BasicStroke(icon_bdr_outer_w, BasicStroke.CAP_SQUARE, BasicStroke.JOIN_MITER, 10.0f, new float[] { 4.0f, 4.0f }, 0.0f);
    BasicStroke ret = solid;
    return ret;
  }

  public boolean icon_state_test(long has_bits) {
    return ((icon_state & has_bits) != 0);
  }

  public boolean icon_state_test(long rs, long has_bits) {
    return ((rs & has_bits) != 0);
  }

  public long icon_state() {
    return icon_state;
  }

  public void icon_state(long unset_bits,long set_bits) {
    //System.out.println(detail_get_string(DETAIL_SERIAL) + ": (b): " + get_states());
    icon_state = (set_bits | (icon_state & ~unset_bits));
    //System.out.println(detail_get_string(DETAIL_SERIAL) + ": (a): " + get_states());
  }

  public void icon_paint(java.awt.Graphics g) {
    g.translate(icon_get_x(), icon_get_y());
    //Graphics2D g2d = (Graphics2D) g;
    icon_piant_borders_and_fill(g);

    //must be after borders and icon_fill
    g.drawImage(icon_img_icon, icon_icon.x, icon_icon.y, null);
    icon_paint_handles(g);
    icon_paint_text(g);
    g.translate(-icon_get_x(), -icon_get_y());
	}

  protected void icon_piant_borders_and_fill(java.awt.Graphics g) {
    Graphics2D g2d = (Graphics2D) g;
    BasicStroke bs;

    if(icon_state_test(SELECTED)) {
      //outer border
      bs = new BasicStroke(icon_bdr_outer_w);
      g2d.setStroke(bs);
      g2d.setColor(Color.black);
      g2d.draw(icon_bdr_outer);

      //center border
      bs = new BasicStroke(icon_bdr_center_w);
      g2d.setStroke(bs);
      g2d.setColor(Color.white);
      g2d.draw(icon_bdr_center);
    }

    //inner boder

    //Fill with white first. just incase its dashed
    g2d.setStroke(new BasicStroke(icon_bdr_center_w));
    g2d.setColor(Color.white);
    g2d.draw(icon_bdr_inner);
    //then fill the other
    g2d.setStroke(icon_get_stroke());
    g2d.setColor(icon_get_color());
    g2d.draw(icon_bdr_inner);

    //fill in the rest white
    g2d.setColor(Color.white);
    g2d.fill(icon_fill);
  }

  protected void icon_paint_handles(java.awt.Graphics g) {
    Graphics2D g2d = (Graphics2D) g;
    BasicStroke bs;
    g2d.setColor(Color.black);
    bs = new BasicStroke(icon_handle_line_w);
    g2d.setStroke(bs);
    g2d.draw(icon_lhandle);
    g2d.draw(icon_rhandle);
  }

  protected void icon_draw_text_centered(Graphics2D g2d, String text, int y) {
    Font f = g2d.getFont();
    Rectangle2D r2d = g2d.getFontMetrics(f).getStringBounds(text, g2d);
    g2d.drawString(text, (int)(45.0 - (r2d.getWidth() / 2)), y);
  }

  protected void icon_paint_text(java.awt.Graphics g) {
    Graphics2D g2d = (Graphics2D) g;
    g2d.setColor(Color.black);

    icon_draw_text_centered(g2d, s1, icon_mac.y);

    icon_model.x = icon_inset;
    icon_draw_text_centered(g2d, s2, icon_model.y);
    icon_draw_text_centered(g2d, s3, icon_serial.y);
  }
}
