package javademo;

import java.awt.KeyEventDispatcher;
import java.awt.KeyboardFocusManager;
import java.awt.event.KeyEvent;
import java.util.Collections;
import java.util.LinkedList;
import java.util.List;

public class CustomIsKeyPressed {
  private static final List<Integer> keys_pressed;
  public static CustomIsKeyPressedEvent ke = null;
  static {
    keys_pressed = Collections.synchronizedList(new LinkedList<Integer>());
    KeyboardFocusManager.getCurrentKeyboardFocusManager().addKeyEventDispatcher(new KeyEventDispatcher() {
      @Override
      public boolean dispatchKeyEvent(KeyEvent e) {
        synchronized (CustomIsKeyPressed.class) {
          switch(e.getID()) {
            case KeyEvent.KEY_PRESSED:
              if(!keys_pressed.contains(e.getKeyCode())) {
                keys_pressed.add(e.getKeyCode());
              }
              break;
            case KeyEvent.KEY_RELEASED:
              if(keys_pressed.contains(e.getKeyCode())) {
                keys_pressed.remove((Integer)e.getKeyCode());
              }
              break;
          }
          if(ke != null) {
            ke.keyPressedEvent(e.getID(), e.getKeyCode());
          }
        }
        return false;
      }
    });
  }

  public static boolean isKeyPressed(int key) {
    synchronized (CustomIsKeyPressed.class) {
      return keys_pressed.contains(key);
    }
  }

  public static void setEventHandler(CustomIsKeyPressedEvent e) {
    ke = e;
  }
}
