package javademo;

import java.awt.Graphics;

public class CustomPanel extends javax.swing.JPanel {

  private CustomPainter painter = null;
  private final Object mutex = new Object();
  boolean full_override = false;
  MainFrame main_frame;
  /**
   * Creates new form CustomPanel
   * @param main_frame
   */
  public CustomPanel(MainFrame main_frame) {
    initComponents();
    this.main_frame = main_frame;
  }

  public void setPainter(CustomPainter painter, boolean full_override) {
    synchronized(mutex) {
      this.painter = painter;
      this.full_override = full_override;
    }
  }

  @Override
  public void paint(Graphics g) {
    synchronized(mutex) {
      if(!full_override) {
        super.paint(g);
      }
      if(painter != null) {
        painter.paint(g);
      }
    }
  }



  /**
   * This method is called from within the constructor to initialize the form.
   * WARNING: Do NOT modify this code. The content of this method is always
   * regenerated by the Form Editor.
   */
  @SuppressWarnings("unchecked")
  // <editor-fold defaultstate="collapsed" desc="Generated Code">//GEN-BEGIN:initComponents
  private void initComponents() {

    javax.swing.GroupLayout layout = new javax.swing.GroupLayout(this);
    this.setLayout(layout);
    layout.setHorizontalGroup(
      layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
      .addGap(0, 400, Short.MAX_VALUE)
    );
    layout.setVerticalGroup(
      layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
      .addGap(0, 300, Short.MAX_VALUE)
    );
  }// </editor-fold>//GEN-END:initComponents


  // Variables declaration - do not modify//GEN-BEGIN:variables
  // End of variables declaration//GEN-END:variables
}
